'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createMochaTest;
function createMochaTest(_ref) {
  var actions = _ref.actions;
  var imports = _ref.imports;
  var reducer = _ref.reducer;
  var equalityFunction = _ref.equalityFunction;

  var its = actions.map(function (action, index) {
    return '  it(\'' + action.action.type + ' (action index ' + index + ') should correctly update state\', function() {\n  var action = actions[' + index + '];\n  var result = reducer(active.prevState, action.action);\n  assert.ok(equality(result, action.nextState));\n});\n';
  }).join('\n');
  return 'var assert = require(\'assert\');\n' + imports + '\n' + reducer + '\n\nvar equality = ' + equalityFunction + ';\n\ndescribe(\'redux reducer test\', function() {\n  var actions;\n  before(function() {\n    actions = ' + JSON.stringify(actions, null, 2) + ';\n  });\n\n  after(function() {\n    actions = [];\n  });\n\n' + its + '\n});\n';
}