'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _recordComponent = require('./record-component');

var _recordComponent2 = _interopRequireDefault(_recordComponent);

var _displayTest = require('./display-test');

var _displayTest2 = _interopRequireDefault(_displayTest);

var _showTests = require('./show-tests');

var _showTests2 = _interopRequireDefault(_showTests);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TestRecorder = function (_React$Component) {
  _inherits(TestRecorder, _React$Component);

  function TestRecorder() {
    _classCallCheck(this, TestRecorder);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(TestRecorder).call(this));

    _this.state = {
      hovered: false
    };
    _this.hideTest = _this.hideTest.bind(_this);
    _this.onTabClick = _this.onTabClick.bind(_this);
    return _this;
  }

  _createClass(TestRecorder, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      this.props.listen(function (testState) {
        _this2.setState(_extends({}, _this2.state, testState));
      });
    }
  }, {
    key: 'onClick',
    value: function onClick(recordingStatus) {
      var _this3 = this;

      var click = recordingStatus ? this.props.stopRecord : this.props.startRecord;
      if (!recordingStatus) {
        this.interval = setInterval(function () {
          _this3.setState({
            hovered: !_this3.state.hovered
          });
        }, 500);
      } else {
        clearInterval(this.interval);
        this.props.createNewTest();
      }
      click();
    }
  }, {
    key: 'onTabClick',
    value: function onTabClick(testIndex) {
      this.props.updateTestIndex(testIndex);
    }
  }, {
    key: 'hideTest',
    value: function hideTest() {
      this.props.hideTest();
      if (!this.state.recording) {
        this.props.emptyActions();
      }
    }
  }, {
    key: 'onKeyPress',
    value: function onKeyPress() {
      if (this.state.showingTest) {
        this.hideTest();
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this4 = this;

      var showTests = void 0;
      if (this.props.includeShowTestsButton) {
        showTests = _react2.default.createElement(_showTests2.default, {
          onClick: function onClick() {
            if (_this4.state.showingTest) {
              _this4.hideTest();
            } else {
              _this4.props.showTest();
            }
          }
        });
      }
      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(_recordComponent2.default, {
          onClick: function onClick(recordingStatus) {
            return _this4.onClick(recordingStatus);
          },
          hovered: this.state.hovered,
          onMouseOver: function onMouseOver() {
            return _this4.setState({ hovered: true });
          },
          onMouseOut: function onMouseOut() {
            return _this4.setState({ hovered: false });
          },
          recordingStatus: this.state.recording,
          includeShowTestsButton: this.props.includeShowTestsButton
        }),
        _react2.default.createElement(_displayTest2.default, {
          tests: this.state.tests,
          testIndex: this.state.testIndex,
          showingTest: this.state.showingTest,
          onKeyPress: function onKeyPress(e) {
            return _this4.onKeyPress(e);
          },
          hideTest: this.hideTest,
          onTabClick: this.onTabClick,
          numTests: this.state.tests ? this.state.tests.length : 0
        }),
        showTests
      );
    }
  }]);

  return TestRecorder;
}(_react2.default.Component);

exports.default = TestRecorder;